searchData={"items":[{"type":"module","doc":"This backend uses the [Redix](https://hex.pm/packages/redix) library to connect to Redis.\n\n    defmodule MyApp.RateLimit do\n      # the default prefix is \"MyApp.RateLimit:\"\n      # the default timeout is :infinity\n      use Hammer, backend: Hammer.Redis, prefix: \"MyApp.RateLimit:\", timeout: :infinity\n    end\n\n    MyApp.RateLimit.start_link(url: \"redis://localhost:6379\")\n\n    # increment and timeout arguments are optional\n    # by default increment is 1 and timeout is as defined in the module\n    {:allow, _count} = MyApp.RateLimit.hit(key, scale, limit)\n    {:allow, _count} = MyApp.RateLimit.hit(key, scale, limit, _increment = 1, _timeout = :infinity)","title":"Hammer.Redis","ref":"Hammer.Redis.html"},{"type":"type","doc":"","title":"Hammer.Redis.redis_opts/0","ref":"Hammer.Redis.html#t:redis_opts/0"},{"type":"extras","doc":"# Hammer.Redis\n\n[![Build Status](https://github.com/ExHammer/hammer-backend-redis/actions/workflows/ci.yml/badge.svg)](https://github.com/ExHammer/hammer-backend-redis/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/hammer_backend_redis.svg)](https://hex.pm/packages/hammer_backend_redis)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/hammer_backend_redis)\n[![Total Download](https://img.shields.io/hexpm/dt/hammer_backend_redis.svg)](https://hex.pm/packages/hammer_backend_redis)\n[![License](https://img.shields.io/hexpm/l/hammer_backend_redis.svg)](https://github.com/ExHammer/hammer-backend-redis/blob/master/LICENSE.md)\n\nA Redis backend for the [Hammer](https://github.com/ExHammer/hammer) rate-limiter.\n\nThis backend is a thin [Redix](https://hex.pm/packages/redix) wrapper. A single connection is used per rate-limiter. It should be enough for most use-cases since packets for rate limiting requests are short (i.e. no head of line blocking) and Redis is OK with [pipelining](https://redis.io/learn/operate/redis-at-scale/talking-to-redis/client-performance-improvements#pipelining) (i.e. we don't block awaiting replies). Consider benchmarking before introducing more connections since TCP performance might be unintuitive. For possible pooling approaches, see Redix docs on [pooling](https://hexdocs.pm/redix/real-world-usage.html#name-based-pool) and also [PartitionSupervisor.](https://hexdocs.pm/elixir/1.17.3/PartitionSupervisor.html) Do not use poolboy or db_connection-like pools since they practically disable pipelining which leads to worse connection utilisation and worse performance.\n\nThe algorithm we are using is the first method described (called \"bucketing\") in [Rate Limiting with Redis](https://youtu.be/CRGPbCbRTHA?t=753).\nIn other sources it's sometimes called a \"fixed window counter\".\n\n**TODO:** document ttl issues if servers are misconfigured","title":"Hammer.Redis","ref":"readme.html"},{"type":"extras","doc":"Hammer-backend-redis\nis [available in Hex](https://hex.pm/packages/hammer_backend_redis), the package\ncan be installed by adding `hammer_backend_redis` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hammer_backend_redis, \"~> 7.0\"}\n  ]\nend\n```","title":"Installation - Hammer.Redis","ref":"readme.html#installation"},{"type":"extras","doc":"Define the rate limiter:\n\n```elixir\ndefmodule MyApp.RateLimit do\n  use Hammer, backend: Hammer.Redis\nend\n```\n\nAnd add it to your app's supervision tree:\n\n```elixir\nchildren = [\n  {MyApp.RateLimit, url: \"redis://localhost:6379\"}\n]\n```\n\nAnd that's it, calls to `MyApp.RateLimit.hit/3` and so on will use Redis to store\nthe rate-limit counters. See the [documentation](https://hexdocs.pm/hammer_backend_redis/Hammer.Redis.html) for more details.","title":"Usage - Hammer.Redis","ref":"readme.html#usage"},{"type":"extras","doc":"You need a running Redis instance. One can be started locally using `docker compose up -d redis`.\nSee the [compose.yml](./compose.yml) for more details.","title":"Run tests locally - Hammer.Redis","ref":"readme.html#run-tests-locally"},{"type":"extras","doc":"If you're having trouble, open an issue on this repo.","title":"Getting Help - Hammer.Redis","ref":"readme.html#getting-help"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"","title":"7.0.0-rc.0 (2024-12-06) - Changelog","ref":"changelog.html#7-0-0-rc-0-2024-12-06"},{"type":"extras","doc":"- Conform to new Hammer API\n- Remove Poolboy as it introduces unnecessary blocking.","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"6.2.0 (2024-12-04) - Changelog","ref":"changelog.html#6-2-0-2024-12-04"},{"type":"extras","doc":"- Package updates\n- Add config to customize the redis prefix\n- Deprecate Elixir 1.12 as this are no longer supported","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"6.1.2 (2022-11-11) - Changelog","ref":"changelog.html#6-1-2-2022-11-11"},{"type":"extras","doc":"- Applied credo suggestions\n- Update dependencies","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"6.1.1 (2022-11-11) - Changelog","ref":"changelog.html#6-1-1-2022-11-11"},{"type":"extras","doc":"- package update and ownership transferred","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"6.1.0 (2019-09-03) - Changelog","ref":"changelog.html#6-1-0-2019-09-03"},{"type":"extras","doc":"- Return actual count upon bucket creation (thanks to @davelively14, https://github.com/ExHammer/hammer-backend-redis/pull/16)","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"6.0.1 (2019-07-13) - Changelog","ref":"changelog.html#6-0-1-2019-07-13"},{"type":"extras","doc":"- Accept an optional `redis_url` option","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- Updated dependencies in test environment (thanks to @ono, https://github.com/ExHammer/hammer-backend-redis/pull/14)","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Fixed a crash in `delete_buckets` (thanks to @ono, https://github.com/ExHammer/hammer-backend-redis/pull/15)","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"","title":"6.0.0 (2018-10-13) - Changelog","ref":"changelog.html#6-0-0-2018-10-13"},{"type":"extras","doc":"- Raise an error if `expiry_ms` is not configured explicitly\n- Update the `redix` dependency to `~> 0.8`","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Actually honor `:redis_config`, as is claimed in the documentation","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"","title":"5.0.0 (2018-10-13) - Changelog","ref":"changelog.html#5-0-0-2018-10-13"},{"type":"extras","doc":"- Update to the new custom-increment api","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"4.0.3 (2018-05-08) - Changelog","ref":"changelog.html#4-0-3-2018-05-08"},{"type":"extras","doc":"- Fix a rare crash, again related to race-conditions\n  (https://github.com/ExHammer/hammer-backend-redis/issues/11#issuecomment-387202359)","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"","title":"4.0.2 (2018-04-27) - Changelog","ref":"changelog.html#4-0-2-2018-04-27"},{"type":"extras","doc":"- Fixed race-condition, really this time\n  (https://github.com/ExHammer/hammer-backend-redis/issues/11)","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"","title":"4.0.1 (2018-04-24) - Changelog","ref":"changelog.html#4-0-1-2018-04-24"},{"type":"extras","doc":"- Fixed a race-condition that could cause crashes\n  (https://github.com/ExHammer/hammer-backend-redis/issues/11)","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"","title":"4.0.0 (2018-04-23) - Changelog","ref":"changelog.html#4-0-0-2018-04-23"},{"type":"extras","doc":"- Update to `Hammer 4.0`","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"3.0.0 (2018-02-20) - Changelog","ref":"changelog.html#3-0-0-2018-02-20"},{"type":"extras","doc":"- Require elixir >= 1.6","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"2.0.0 (2017-09-24) - Changelog","ref":"changelog.html#2-0-0-2017-09-24"},{"type":"extras","doc":"- Updated to new Hammer API","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"1.0.0 (2017-08-27) - Changelog","ref":"changelog.html#1-0-0-2017-08-27"},{"type":"extras","doc":"- `hammer_backend_redis` now explicitly depends on `hammer`\n- Implement the `Hammer.Backend` behaviour\n- Alias `redix_config` to `redis_config` in the config list, for convenience","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"Initial release.","title":"0.1.0 (2017-07-31) - Changelog","ref":"changelog.html#0-1-0-2017-07-31"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}